diff -rNci gcc-2.7.2/reg-stack.c gcc-2.7.2p/reg-stack.c
*** gcc-2.7.2/reg-stack.c	Thu Jun 15 21:36:05 1995
--- gcc-2.7.2p/reg-stack.c	Tue Jan 23 09:25:29 1996
***************
*** 3131,3134 ****
--- 3136,5348 ----
        fprintf (file, "\n");
      }
  }
+ /* intel1 */
+ #ifdef IS_STACK_MODE
+ #include "basic-block.h"
+ #include "obstack.h"
+ #define obstack_chunk_alloc xmalloc
+ #define obstack_chunk_free free
+ 
+ extern int regset_bytes;
+ extern struct obstack momentary_obstack;
+ extern rtx *regno_reg_rtx;
+ extern int max_regno;
+ 
+ static void func_stack_reg_to_stack_slot ();
+ static void bb_stack_reg_to_stack_slot ();
+ void float_to_int_cmp ();
+ static void offload_if_necessary ();
+ static void offload_reg ();
+ static void replace_with_stack_slot ();
+ static int stack_reg_dies_at_store ();
+ static void mark_stack_regs_mentioned ();
+ static void replace_with_temp_slot ();
+ static int reg_dead_at_pred ();
+ static int reg_only_set_or_stored ();
+ static int reg_used_in_body ();
+ static int store_into_temp ();
+ static int visit_till_dies ();
+ static int addr_or_val_changed ();
+ static void find_regs_mentioned ();
+ static int tests_equality ();
+ static int reg_last_loaded ();
+ static int reg_def_in_unvisited ();
+ static rtx reg_dies_in_block ();
+ static int death_blocks_ok ();
+ 
+ /* For each basic block the union of the basic_block_live_at_start
+    of each of it's successors.  */
+ regset *basic_block_maybe_live_at_end;
+ 
+ /* To mark each block visited on a path */
+ char *blocks_visited;
+ 
+ /* To mark those blocks on the path where the reg dies.
+    It is set to the NEXT_INSN of the insn in the block where
+    the reg dies */
+ rtx *death_blocks;
+ 
+ /* To mark those blocks where the reg is defined */
+ char *blocks_defined;
+ 
+ /* For finding block sucessors */
+ int *fall_thru_block, *jump_target_block;
+ 
+ /* The temp slots allocated to stack regs */
+ rtx *reg_temp_slot;
+ 
+ int num_visits;
+ 
+ /* Information collected for optimizing use of stack regs
+    within a basic block
+ */
+ struct stack_reg_infos
+   {
+     rtx store_insn;
+     rtx non_dead_store[3];
+     rtx last_use;
+     unsigned char num_non_dead_store;
+     unsigned char dies_at_store;
+   }
+ 
+  *stack_reg_info;
+ 
+ static
+ struct regs_mentioned
+   {
+     rtx reg;
+     struct regs_mentioned *next;
+   } *reg_mentioned_header;
+ 
+ void init_regset_vector ();
+ 
+ void
+ opt_reg_stack ()
+ {
+ 
+   reg_temp_slot = (rtx *) alloca (max_regno * sizeof (rtx));
+   bzero (reg_temp_slot, max_regno * sizeof (rtx));
+ 
+   if (stack_reg_dump_file)
+     {
+       fprintf (stack_reg_dump_file," MAX_REGNO at start %d\n",max_regno);
+     }
+   func_stack_reg_to_stack_slot ();
+   bb_stack_reg_to_stack_slot ();
+ #ifdef SPARE_REGS
+   max_regno = max_reg_num();
+   if (stack_reg_dump_file)
+     {
+       fprintf (stack_reg_dump_file," MAX_REGNO at end %d\n",max_regno);
+     }
+ #endif
+ }
+ 
+ /*
+    Stack mode registers that are used only to move values
+    in a basic block are replaced with stack slots.
+    We also have something like this for between basic blocks
+    see the ear spec agc()/earfilters.c the last loop
+ */
+ static void
+ bb_stack_reg_to_stack_slot ()
+ {
+   int block, nregs, stack_regno, num_calls;
+   rtx insn;
+ 
+   nregs = max_regno;
+   stack_reg_info = (struct stack_reg_infos *)
+     alloca (nregs * sizeof (struct stack_reg_infos));
+ 
+   for (block = 0; block < n_basic_blocks; block++)
+     {
+       bzero (stack_reg_info, nregs * sizeof (struct stack_reg_infos));
+       num_calls = 0;
+       for (insn = basic_block_end[block];
+ 	   insn && insn != PREV_INSN (basic_block_head[block]);
+ 	   insn = PREV_INSN (insn))
+ 	{
+ 	  if (GET_CODE (insn) == CALL_INSN)
+ 	    num_calls++;
+ 	  if (GET_CODE (insn) == INSN)
+ 	    {
+ 	      if (GET_CODE (PATTERN (insn)) != SET)
+ 		{
+ 		  if (GET_CODE (PATTERN (insn)) == PARALLEL)
+ 		    {
+ 		      if (flag_do_offload)
+ 			offload_if_necessary (insn, block);
+ 		    }
+ 		  bzero (stack_reg_info, nregs * sizeof (struct stack_reg_infos));
+ 		}
+ 	      else
+ 		{
+ 		  if (GET_CODE (SET_DEST (PATTERN (insn))) == REG
+ 		      && GET_MODE (SET_DEST (PATTERN (insn))) == SFmode
+ 		      && GET_CODE (SET_SRC (PATTERN (insn))) == FLOAT_TRUNCATE)
+ 		    {
+ 		      rtx slot;
+ 		      slot 
+ 		        = assign_stack_local (SFmode, GET_MODE_SIZE (SFmode), -1);
+ 		      emit_insn_after (gen_rtx (SET, 0, SET_DEST (PATTERN (insn)),
+ 		                                slot), insn);
+ 		      SET_DEST (PATTERN (insn)) = slot;
+ 		    }
+ 		  stack_regno = -1;
+ 		  if (stack_reg_dies_at_store (insn, &stack_regno))
+ 		    { /* A store of stack_regno at which it dies.  */
+ 		      stack_reg_info[stack_regno].dies_at_store = 1;
+ 		      stack_reg_info[stack_regno].store_insn = insn;
+ 		      stack_reg_info[stack_regno].num_non_dead_store = 0;
+ 		    }
+ 		  else if (stack_regno != -1)
+ 		    {
+ 		      /* Stored but not dead.  */
+ 		      stack_reg_info[stack_regno].num_non_dead_store++;
+ 		      if (stack_reg_info[stack_regno].num_non_dead_store <= 3)
+ 			{
+ 			  stack_reg_info[stack_regno].non_dead_store
+ 			    [stack_reg_info[stack_regno].num_non_dead_store - 1] 
+ 			    = insn;
+ 			}
+ 		      else
+ 			{
+ 			  stack_reg_info[stack_regno].dies_at_store = 0;
+ 			  stack_reg_info[stack_regno].store_insn = NULL;
+ 			  stack_reg_info[stack_regno].last_use = NULL;
+ 			  stack_reg_info[stack_regno].num_non_dead_store = 0;
+ 			}
+ 		    }
+ 		  else
+ 		    mark_stack_regs_mentioned (SET_SRC (PATTERN (insn)), insn);
+ 		  if (GET_CODE (SET_DEST (PATTERN (insn))) != REG)
+ 		    mark_stack_regs_mentioned (SET_DEST (PATTERN (insn)), insn);
+ 		  if (GET_CODE (SET_DEST (PATTERN (insn))) == REG
+ 		      && IS_STACK_MODE (GET_MODE (SET_DEST (PATTERN (insn))))
+ 		    )
+ 		    { /* A setting of a stack register.  */
+ 		      if (((GET_CODE (SET_SRC (PATTERN (insn))) == MEM
+ 			     && !MEM_VOLATILE_P (SET_SRC (PATTERN (insn))))
+ 			   || GET_CODE (SET_SRC (PATTERN (insn))) == CONST_DOUBLE)
+ 			  && stack_reg_info[REGNO (SET_DEST (PATTERN (insn)))].dies_at_store)
+ 			{ /* It is loaded from a non volatile memory and
+ 			     was stored upon death later in the basic block,
+ 			     try to do this NOT via the register stack.  */
+ 			  replace_with_stack_slot (insn, block, num_calls);
+ 			}
+ 		      else
+ 			{ /* Just try to optimize consecutive stores and
+ 			     restart the information gathering.  
+ 			  */
+ 			  stack_regno = REGNO (SET_DEST (PATTERN (insn)));
+ 			  opt_consec_stores (stack_regno);
+ 			  stack_reg_info[stack_regno].dies_at_store = 0;
+ 			  stack_reg_info[stack_regno].store_insn = NULL;
+ 			  stack_reg_info[stack_regno].last_use = NULL;
+ 			  stack_reg_info[stack_regno].num_non_dead_store = 0;
+ 			}
+ 		    }
+ 		}
+ 	    }
+ 	}
+     }
+ }
+ 
+ /*
+     Change
+             fst   mem1
+             fstp  mem2
+     to
+            fstp  mem1
+            mov   mem1,mem2
+     regno is the number of the stack register being stored.  
+ */
+ opt_consec_stores (regno)
+      int regno;
+ {
+   rtx insn, note;
+ 
+   if (stack_reg_info[regno].store_insn
+       && stack_reg_info[regno].dies_at_store
+       && stack_reg_info[regno].num_non_dead_store != 0
+       && stack_reg_info[regno].non_dead_store[0] ==
+       PREV_INSN (stack_reg_info[regno].store_insn))
+     {
+       insn = stack_reg_info[regno].store_insn;
+       SET_SRC (PATTERN (insn)) 
+ 	= copy_rtx (SET_DEST (PATTERN (stack_reg_info[regno].non_dead_store[0])));
+       if (GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == PRE_DEC
+ 	  || GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == PRE_INC)
+ 	{
+ 	  XEXP (SET_SRC (PATTERN (insn)), 0) =
+ 	    XEXP (XEXP (SET_SRC (PATTERN (insn)), 0), 0);
+ 	}
+       INSN_CODE (insn) = recog (PATTERN (insn), insn, 0);
+       note = find_regno_note (insn, REG_DEAD, regno);
+       remove_note (insn, note);
+       if (!find_regno_note (stack_reg_info[regno].non_dead_store[0], REG_DEAD, regno))
+ 	{
+ 	  REG_NOTES (stack_reg_info[regno].non_dead_store[0])
+ 	    = gen_rtx (EXPR_LIST, REG_DEAD, regno_reg_rtx[regno],
+ 		       REG_NOTES (stack_reg_info[regno].non_dead_store[0]));
+ 	}
+     }
+ }
+ 
+ 
+ /*
+   If the register being compared is the result of a computation in
+   this block, and the second comparison operand is not so, and it is
+   being compared for equality.  
+     offload and reload it before the compare
+   The reason for this is that the stack registers are 80bit precision
+   and hence the comparison may fail due to precision.  
+ */
+ 
+ static void
+ offload_if_necessary (insn, blocknum)
+      rtx insn;
+      int blocknum;
+ {
+   rtx cmp_part, new_insn, last_set_insn, assign_stack_local ();
+   int regno;
+ 
+   if (GET_CODE (XVECEXP (PATTERN (insn), 0, 0)) == SET)
+     {
+       cmp_part = XVECEXP (PATTERN (insn), 0, 0);
+       last_set_insn = NULL;
+       if (SET_DEST (cmp_part) == cc0_rtx
+ 	  && GET_CODE (SET_SRC (cmp_part)) == COMPARE
+ 	  && GET_MODE (SET_SRC (cmp_part)) == CCmode)
+ 	{
+ 	  if (GET_CODE (XEXP (SET_SRC (cmp_part), 0)) == REG
+ 	      && GET_MODE (XEXP (SET_SRC (cmp_part), 0)) == DFmode
+ 	      && GET_CODE (XEXP (SET_SRC (cmp_part), 1)) != REG
+ 	      && !reg_last_loaded (blocknum, PREV_INSN (insn),
+ 		       REGNO (XEXP (SET_SRC (cmp_part), 0)), &last_set_insn)
+ 	      && last_set_insn
+ 	      && tests_equality (NEXT_INSN (insn)))
+ 	    {
+ 	      regno = REGNO (XEXP (SET_SRC (cmp_part), 0));
+ 	      if (reg_temp_slot[regno] == NULL)
+ 		{
+ 		  reg_temp_slot[regno] 
+ 		    = assign_stack_local (GET_MODE (XEXP (SET_SRC (cmp_part), 0)),
+ 		    GET_MODE_SIZE (GET_MODE (XEXP (SET_SRC (cmp_part), 0))),
+ 					-1);
+ 		}
+ 	      MEM_VOLATILE_P (reg_temp_slot[regno]) = 1;
+ 	      new_insn 
+ 		= emit_insn_before (
+ 				   gen_rtx (SET, 0,
+ 			reg_temp_slot[regno], XEXP (SET_SRC (cmp_part), 0)),
+ 				   insn);
+ 	      if (basic_block_head[blocknum] == insn)
+ 		{
+ 		  basic_block_head[blocknum] = new_insn;
+ 		}
+ 	      REG_NOTES (new_insn) 
+ 		= gen_rtx (EXPR_LIST, REG_DEAD,
+ 			 XEXP (SET_SRC (cmp_part), 0),
+ 			 REG_NOTES (new_insn));
+ 	      reg_n_deaths[regno]++;
+ 	      emit_insn_before (
+ 				 gen_rtx (SET, 0,
+ 			XEXP (SET_SRC (cmp_part), 0), reg_temp_slot[regno]),
+ 				 insn);
+ 	    }
+ 	}
+     }
+ }
+ 
+ 
+ /*
+   Return 1 if the insn which is a jump insn tests for equality or
+   inequality
+   else return 0
+ */
+ 
+ static int
+ tests_equality (insn)
+      rtx insn;
+ {
+   if (GET_CODE (insn) == JUMP_INSN &&
+       GET_CODE (PATTERN (insn)) == SET &&
+       SET_DEST (PATTERN (insn)) == pc_rtx &&
+       GET_CODE (SET_SRC (PATTERN (insn))) == IF_THEN_ELSE &&
+       (GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == NE ||
+        GET_CODE (XEXP (SET_SRC (PATTERN (insn)), 0)) == EQ))
+     {
+       return (1);
+     }
+   return (0);
+ }
+ 
+ 
+ /*
+    Search backward in block# blocknum, beginning at insn for a set of
+    reg# regno. 
+    if found
+      set *last_set_insn to that set
+      if the source that sets regno is one of the desired sources
+      (see below) return 1
+      else return 0
+    else return 0
+ */
+ static int
+ reg_last_loaded (blocknum, insn, regno, last_set_insn)
+      int blocknum, regno;
+      rtx insn, *last_set_insn;
+ {
+   rtx last_set;
+   int found, i;
+ 
+   last_set = insn;
+   found = 0;
+   while (!found && last_set != PREV_INSN (basic_block_head[blocknum]))
+     {
+       if (GET_CODE (last_set) == INSN)
+ 	{
+ 	  if (GET_CODE (PATTERN (last_set)) == PARALLEL)
+ 	    {
+ 	      for (i = 0; i < XVECLEN (PATTERN (last_set), 0); i++)
+ 		{
+ 		  if (GET_CODE (XVECEXP (PATTERN (last_set), 0, i)) == SET)
+ 		    {
+ 		      if (GET_CODE (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == REG &&
+ 			  REGNO (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == regno)
+ 			{
+ 			  *last_set_insn = last_set;
+ 			  return (0);
+ 			}
+ 		    }
+ 		  else if (GET_CODE (XVECEXP (PATTERN (last_set), 0, i)) == CLOBBER)
+ 		    {
+ 		      if (GET_CODE (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == REG &&
+ 			  REGNO (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == regno)
+ 			{
+ 			  *last_set_insn = last_set;
+ 			  return (0);
+ 			}
+ 		    }
+ 		  else
+ 		    {
+ 		      return (0);
+ 		    }
+ 		}
+ 	    }
+ 	  if ((GET_CODE (PATTERN (last_set)) == SET ||
+ 	       GET_CODE (PATTERN (last_set)) == CLOBBER) &&
+ 	      GET_CODE (SET_DEST (PATTERN (last_set))) == REG &&
+ 	      REGNO (SET_DEST (PATTERN (last_set))) == regno)
+ 	    {
+ 	      if (GET_CODE (PATTERN (last_set)) == CLOBBER)
+ 		{
+ 		  *last_set_insn = last_set;
+ 		  return (0);
+ 		}
+ 	      if (GET_CODE (SET_SRC (PATTERN (last_set))) != MEM
+ 		  && GET_CODE (SET_SRC (PATTERN (last_set))) != CONST_DOUBLE
+ 		  && GET_CODE (SET_SRC (PATTERN (last_set))) != REG
+ 		  && GET_CODE (SET_SRC (PATTERN (last_set))) != SUBREG
+ 		  && GET_CODE (SET_SRC (PATTERN (last_set))) != FLOAT
+ 		  && GET_CODE (SET_SRC (PATTERN (last_set))) != FLOAT_EXTEND)
+ 		{
+ 		  *last_set_insn = last_set;
+ 		  return (0);
+ 		}
+ 	      else
+ 		{
+ 		  *last_set_insn = last_set;
+ 		  if (GET_CODE (SET_SRC (PATTERN (last_set))) == REG &&
+ 		      REGNO (SET_SRC (PATTERN (last_set))) < FIRST_PSEUDO_REGISTER)
+ 		    return (0);
+ 		  return (1);
+ 		}
+ 	    }
+ 	}
+       if (!found)
+ 	{
+ 	  last_set = PREV_INSN (last_set);
+ 	}
+     }
+   return (0);
+ }
+ 
+ 
+ /*
+   insn loads a stack reg from memory and later on in the block
+   at stack_reg_info[REGNO(SET_DEST(PATTERN(insn)))].store_insn
+   that stack reg is stored into memory and marked as dead.  Also
+   no insn between these two insns sets that stack reg. 
+   This procedure changes the store from the register stack to
+   a store from the regular stack - which is faster.  
+ */
+ static void
+ replace_with_stack_slot (insn, block_num, num_calls)
+      rtx insn;
+      int block_num, num_calls;
+ {
+   rtx note, stack_slot, store_insn, new_insn;
+   rtx notes_to_move, assign_stack_local ();
+   int i, regno, mem_possibly_changed;
+   char *storage;
+ 
+   notes_to_move = NULL;
+   regno = REGNO (SET_DEST (PATTERN (insn)));
+   store_insn = stack_reg_info[regno].store_insn;
+   storage = (char *) obstack_alloc (&momentary_obstack, 0);
+ 
+   /* Check if the memory being loaded into the stack register may
+      possibly change between insn and store_insn.  
+   */
+   mem_possibly_changed 
+     = (GET_CODE (SET_SRC (PATTERN (insn))) == CONST_DOUBLE) ? 0 :
+       addr_or_val_changed (SET_SRC (PATTERN (insn)), insn, store_insn);
+   obstack_free (&momentary_obstack, storage);
+   if (stack_reg_dump_file)
+     {
+       fprintf (stack_reg_dump_file,
+ 	       "Offload stack reg%d used only within basic block insn %d store_insn %d\n",
+        regno, INSN_UID (insn), INSN_UID (stack_reg_info[regno].store_insn));
+       if (stack_reg_info[regno].last_use != NULL)
+ 	{
+ 	  fprintf (stack_reg_dump_file,
+ 		   " reg used at insn %d\n",
+ 		   INSN_UID (stack_reg_info[regno].last_use));
+ 	}
+     }
+   if (reg_temp_slot[regno] == NULL && mem_possibly_changed)
+     { /* Must allocate a stack slot */
+ #ifdef SPARE_REGS
+       if (max_reg_num () < max_regno)
+         {
+           if (GET_MODE (SET_DEST (PATTERN (insn))) == SFmode)
+             reg_temp_slot[regno] = gen_reg_rtx (SImode);
+           else
+             reg_temp_slot[regno] 
+ 	      = assign_stack_local (GET_MODE (SET_DEST (PATTERN (insn))),
+ 		   GET_MODE_SIZE (GET_MODE (SET_DEST (PATTERN (insn)))),
+ 			    -1);
+         }
+       else
+ #endif
+         reg_temp_slot[regno] 
+ 	  = assign_stack_local (GET_MODE (SET_DEST (PATTERN (insn))),
+ 		       GET_MODE_SIZE (GET_MODE (SET_DEST (PATTERN (insn)))),
+ 			    -1);
+     }
+   if (mem_possibly_changed)
+     /* Use the stack slot */
+     stack_slot = reg_temp_slot[regno];
+   else
+     /* The memory slot from which the stack register was loaded can be used */
+     stack_slot = SET_SRC (PATTERN (insn));
+   if (stack_reg_info[regno].last_use == NULL)
+     { /* The stack register was not used between the load and store */
+       if (mem_possibly_changed)
+ 	{
+ 	  SET_DEST (PATTERN (insn)) = stack_slot;
+ 	  if (GET_CODE (stack_slot) == REG)
+ 	    {
+               if (GET_CODE (SET_SRC (PATTERN (insn)))
+                   == CONST_DOUBLE)
+                 {
+                   SET_SRC (PATTERN (insn)) = 
+                     gen_rtx (CONST_INT, 0, CONST_DOUBLE_HIGH (SET_SRC (PATTERN (insn))));
+                 }
+               else
+                 {
+ 	          PUT_MODE (SET_SRC (PATTERN (insn)), GET_MODE (stack_slot));
+ 	        }
+ 	    }
+ 	  INSN_CODE (insn) = recog (PATTERN (insn), insn, 0);
+ 	}
+       else
+ 	{
+ 	  PUT_CODE (insn, NOTE);
+ 	  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+ 	  NOTE_SOURCE_FILE (insn) = 0;
+ 	  notes_to_move = REG_NOTES (insn);
+ 	}
+     }
+   else
+     { /* The stack register was also used in some computation */
+       if (mem_possibly_changed)
+ 	{
+ 	  new_insn 
+ 	    = emit_insn_after (
+ 	  gen_rtx (SET, 0, stack_slot, copy_rtx (SET_SRC (PATTERN (insn)))),
+ 			      insn);
+ 	  if (GET_CODE (stack_slot) == REG)
+ 	    {
+ 	      PUT_MODE (SET_SRC (PATTERN (new_insn)), GET_MODE (stack_slot));
+ 	    }
+ 	  INSN_CODE (new_insn) = recog (PATTERN (new_insn), new_insn, 0);
+ 	}
+     }
+   SET_SRC (PATTERN (store_insn)) = stack_slot;
+   if (GET_CODE (stack_slot) == REG )
+     {
+       reg_n_refs[REGNO (stack_slot)]++;
+       reg_n_sets[REGNO (stack_slot)]++;
+       reg_n_calls_crossed[REGNO (stack_slot)] = num_calls;
+       reg_n_deaths[REGNO (stack_slot)]++;
+       if (reg_basic_block[REGNO (stack_slot)] != -1)
+         {
+           reg_basic_block[REGNO (stack_slot)] = REG_BLOCK_GLOBAL;
+         }
+       else
+         {
+           reg_basic_block[REGNO (stack_slot)] = block_num;
+         }
+       PUT_MODE (SET_DEST (PATTERN (store_insn)), GET_MODE (stack_slot));
+       REG_NOTES (store_insn) = 
+         gen_rtx (EXPR_LIST, REG_DEAD, stack_slot, REG_NOTES (store_insn));
+     }
+   INSN_CODE (store_insn) = recog (PATTERN (store_insn), store_insn, 0);
+   note = find_regno_note (store_insn, REG_DEAD, regno);
+   remove_note (store_insn, note);
+   if (notes_to_move)
+     { /* Maintain consistency of REG NOTE information */
+       rtx link, prev_link;
+       prev_link = REG_NOTES (store_insn);
+       for (link = REG_NOTES (store_insn); link; link = XEXP (link, 1))
+ 	{
+ 	  prev_link = link;
+ 	}
+       if (prev_link)
+ 	{
+ 	  XEXP (prev_link, 1) = notes_to_move;
+ 	}
+       else
+ 	{
+ 	  REG_NOTES (store_insn) = notes_to_move;
+ 	}
+     }
+   if (stack_reg_info[regno].last_use == NULL)
+     {
+       reg_n_deaths[regno]--;
+     }
+   else if (!find_regno_note (stack_reg_info[regno].last_use, REG_DEAD, regno))
+     {
+       REG_NOTES (stack_reg_info[regno].last_use)
+ 	= gen_rtx (EXPR_LIST, REG_DEAD, regno_reg_rtx[regno],
+ 		   REG_NOTES (stack_reg_info[regno].last_use));
+     }
+   for (i = 0;
+        i < (int) stack_reg_info[regno].num_non_dead_store;
+        i++)
+     { /* Handle the stores of the stack register that were done
+          between insn and store_insn.  */
+       store_insn 
+ 	= stack_reg_info[regno].non_dead_store[i];
+       SET_SRC (PATTERN (store_insn)) = stack_slot;
+       if (GET_CODE (stack_slot) == REG )
+         {
+           reg_n_refs[REGNO (stack_slot)]++;
+           PUT_MODE (SET_DEST (PATTERN (store_insn)), GET_MODE (stack_slot));
+         }
+       INSN_CODE (store_insn) = recog (PATTERN (store_insn), store_insn, 0);
+     }
+   stack_reg_info[regno].store_insn = NULL;
+   stack_reg_info[regno].last_use = NULL;
+   stack_reg_info[regno].num_non_dead_store = 0;
+   stack_reg_info[regno].dies_at_store = 0;
+ }
+ 
+ 
+ 
+ /*
+   GET_CODE(mem) is MEM
+   we are interested in the insns between start_insn and stop_insn
+   (non inclusive)
+   return 1 if the address of mem or the contents of mem may POSSIBLY
+   be changed in this interval
+   return 0 otherwise
+     by address of mem changing we mean that mem contains a base and/or
+     index register and some insn in the interval sets the register.
+ */
+ static int
+ addr_or_val_changed (mem, start_insn, stop_insn)
+      rtx mem, start_insn, stop_insn;
+ {
+   rtx insn;
+   struct regs_mentioned *a_reg_mentioned;
+   char * storage;
+ 
+   if (MEM_VOLATILE_P (mem))
+     {
+       return (1);
+     }
+   /*
+   if (RTX_UNCHANGING_P (mem))
+     {
+       return (0);
+     } */
+   reg_mentioned_header = NULL;
+   storage = (char *) obstack_alloc (&momentary_obstack, 0);
+   find_regs_mentioned (mem);
+   for (insn = NEXT_INSN (start_insn); insn != stop_insn; insn = NEXT_INSN (insn))
+     {
+       if (GET_CODE (insn) == CALL_INSN || GET_CODE (insn) == CODE_LABEL)
+ 	{
+ 	  return (1);
+ 	}
+       if (GET_CODE (insn) == INSN)
+ 	{
+ 	  if (GET_CODE (PATTERN (insn)) == SET || GET_CODE (PATTERN (insn)) == CLOBBER)
+ 	    {
+ 	      if (GET_CODE (SET_DEST (PATTERN (insn))) == MEM)
+ 		{
+ 		  if (true_dependence (mem, SET_DEST (PATTERN (insn))))
+ 		    {
+ 		      obstack_free (&momentary_obstack, storage);
+ 		      return (1);
+ 		    }
+ 		}
+ 	      else if (GET_CODE (SET_DEST (PATTERN (insn))) == REG)
+ 		{
+ 		  for (a_reg_mentioned = reg_mentioned_header;
+ 		       a_reg_mentioned != NULL;
+ 		       a_reg_mentioned = a_reg_mentioned->next)
+ 		    {
+ 		      if (reg_overlap_mentioned_p (SET_DEST (PATTERN (insn)),
+ 						   a_reg_mentioned->reg)
+ 			)
+ 			{
+   		          obstack_free (&momentary_obstack, storage);
+ 			  return (1);
+ 			}
+ 		    }
+ 		}
+ 	      else
+ 		{
+ 		  obstack_free (&momentary_obstack, storage);
+ 		  return (1);
+ 		}
+ 	    }
+ 	  else
+ 	    {
+ 	      obstack_free (&momentary_obstack, storage);
+ 	      return (1);
+ 	    }
+ 	}
+     }
+   obstack_free (&momentary_obstack, storage);
+   return (0);
+ }
+ 
+ 
+ /* Build a linked list of (struct regs_mentioned) describing the
+    registers used in the pattern pat.  
+ */
+ static void
+ find_regs_mentioned (pat)
+      rtx pat;
+ {
+   register char *fmt;
+   register int i;
+   register enum rtx_code code;
+   struct regs_mentioned *one_reg;
+ 
+   code = GET_CODE (pat);
+ 
+   switch (code)
+     {
+     case REG:
+       one_reg = (struct regs_mentioned *)
+ 	obstack_alloc (&momentary_obstack, sizeof (struct regs_mentioned));
+       one_reg->reg = pat;
+       one_reg->next = reg_mentioned_header;
+       reg_mentioned_header = one_reg;
+       return;
+ 
+       /* These codes have no constituent expressions
+ 	 and are unique.  */
+     case SCRATCH:
+     case CC0:
+     case PC:
+     case QUEUED:
+     case CONST_INT:
+     case CONST_DOUBLE:
+     case SYMBOL_REF:
+     case CODE_LABEL:
+       return;
+ 
+ 
+     }
+ 
+ 
+   fmt = GET_RTX_FORMAT (code);
+ 
+   for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
+     {
+       if (fmt[i] == 'E')
+ 	{
+ 	  register int j;
+ 	  for (j = XVECLEN (pat, i) - 1; j >= 0; j--)
+ 	    find_regs_mentioned (XVECEXP (pat, i, j));
+ 	}
+       else if (fmt[i] == 'e')
+ 	find_regs_mentioned (XEXP (pat, i));
+     }
+ }
+ 
+ 
+ /*
+   if insn stores a stack register into memory
+     set *regno to the register# stored
+     if the stack register is marked dead at the store
+       return 1
+     else
+       return 0
+ */
+ static int
+ stack_reg_dies_at_store (insn, regno)
+      rtx insn;
+      int *regno;
+ {
+   if (GET_CODE (SET_DEST (PATTERN (insn))) == MEM
+       && GET_CODE (SET_SRC (PATTERN (insn))) == REG
+       && IS_STACK_MODE (GET_MODE (SET_SRC (PATTERN (insn))))
+     )
+     {
+       *regno = REGNO (SET_SRC (PATTERN (insn)));
+       return ((int) find_regno_note (insn, REG_DEAD, *regno));
+     }
+   return (0);
+ }
+ 
+ 
+ /*
+   Record relevant information on each stack register that is mentioned
+   in pat which is a subexpression of insn.  
+ */
+ static void
+ mark_stack_regs_mentioned (pat, insn)
+      rtx pat, insn;
+ {
+   register char *fmt;
+   register int i;
+   register enum rtx_code code;
+ 
+   code = GET_CODE (pat);
+ 
+   switch (code)
+     {
+     case REG:
+       if (IS_STACK_MODE (GET_MODE (pat)))
+ 	{
+ 	  if (stack_reg_info[REGNO (pat)].last_use == NULL)
+ 	    {
+ 	      stack_reg_info[REGNO (pat)].last_use = insn;
+ 	    }
+ 	}
+       return;
+ 
+       /* These codes have no constituent expressions
+ 	 and are unique.  */
+     case SCRATCH:
+     case CC0:
+     case PC:
+     case QUEUED:
+     case CONST_INT:
+     case CONST_DOUBLE:
+     case SYMBOL_REF:
+     case CODE_LABEL:
+       return;
+ 
+ 
+     }
+ 
+ 
+   fmt = GET_RTX_FORMAT (code);
+ 
+   for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
+     {
+       if (fmt[i] == 'E')
+ 	{
+ 	  register int j;
+ 	  for (j = XVECLEN (pat, i) - 1; j >= 0; j--)
+ 	    mark_stack_regs_mentioned (XVECEXP (pat, i, j), insn);
+ 	}
+       else if (fmt[i] == 'e')
+ 	mark_stack_regs_mentioned (XEXP (pat, i), insn);
+     }
+ }
+ 
+ 
+ /*
+    Stack mode registers that are set in one basic block and only
+    loaded to or stored from in successor blocks are replaced with
+    stack slots in the successor blocks. 
+ */
+ static void
+ func_stack_reg_to_stack_slot ()
+ {
+   rtx head, tail, target;
+   register regset tem;
+   int i, j, found, target_blocknum, regno, successful_visit, reg_defined_elsewhere,
+     reg_set_or_stored, cmprd, only_cmp;
+   char *storage;
+ #ifdef SPARE_REGS
+    int max_regno = max_reg_num ();
+ #endif
+ 
+ 
+   storage = (char *) obstack_alloc (&momentary_obstack, 0);
+   basic_block_maybe_live_at_end = (regset *) alloca (n_basic_blocks * sizeof (regset));
+   tem = (regset) obstack_alloc (&momentary_obstack, n_basic_blocks * regset_bytes);
+   bzero (tem, n_basic_blocks * regset_bytes);
+   init_regset_vector (basic_block_maybe_live_at_end, tem, n_basic_blocks, regset_bytes);
+   jump_target_block = (int *) alloca (n_basic_blocks * sizeof (int));
+   fall_thru_block = (int *) alloca (n_basic_blocks * sizeof (int));
+   blocks_visited = (char *) alloca (n_basic_blocks * sizeof (char));
+   death_blocks = (rtx *) alloca (n_basic_blocks * sizeof (rtx));
+   blocks_defined = (char *) alloca (n_basic_blocks * sizeof (char));
+   cmprd = 0;
+   only_cmp = 1;
+ 
+   if (stack_reg_dump_file)
+     {
+       fprintf (stack_reg_dump_file,
+ 	       "Offload stack regs:\n\n");
+     }
+   /* Find block successors */
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       jump_target_block[i] = -1;
+       fall_thru_block[i] = -1;
+       head = basic_block_head[i];
+       tail = basic_block_end[i];
+       if (GET_CODE (tail) == JUMP_INSN)
+ 	{
+ 	  target = JUMP_LABEL (tail);
+ 	  if (target == NULL)
+ 	    {
+ 	      return;
+ 	    }
+ 	  /* target is the head of the basic block jumped to
+              find which block it is */
+ 	  target_blocknum = 0;
+ 	  found = 0;
+ 	  while (target_blocknum < n_basic_blocks && !found)
+ 	    {
+ 	      if (basic_block_head[target_blocknum] == target)
+ 		{
+ 		  found = 1;
+ 		}
+ 	      else
+ 		{
+ 		  target_blocknum++;
+ 		}
+ 	    }
+ 	  if (!found)
+ 	    {
+ 	      return;
+ 	    }
+ 	  jump_target_block[i] = target_blocknum;
+ 	  for (j = 0; j < regset_size; j++)
+ 	    basic_block_maybe_live_at_end[i][j]
+ 	      |= basic_block_live_at_start[target_blocknum][j];
+ 	}
+       if (!simplejump_p (tail))
+ 	{
+ 	  if (i < n_basic_blocks - 1)
+ 	    {
+ 	      fall_thru_block[i] = i + 1;
+ 	      for (j = 0; j < regset_size; j++)
+ 		basic_block_maybe_live_at_end[i][j]
+ 		  |= basic_block_live_at_start[i + 1][j];
+ 	    }
+ 	}
+     }
+   if (stack_reg_dump_file)
+     my_dump_block_info ();
+   /* Do inter block optimizations */
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       for (regno = FIRST_PSEUDO_REGISTER; regno < max_regno; regno++)
+ 	{
+ 	  register int offset = regno / REGSET_ELT_BITS;
+ 	  register int bit = 1 << (regno % REGSET_ELT_BITS);
+ 	  if (stack_reg_dump_file
+ 	      && IS_STACK_MODE (GET_MODE (regno_reg_rtx[regno]))
+ 	      && (basic_block_maybe_live_at_end[i][offset] & bit)
+ 	      && !(basic_block_live_at_start[i][offset] & bit)
+ 	    )
+ 	    {
+ 	      fprintf (stack_reg_dump_file,
+ 		       "\nstack reg%d in block %d  d_a_p %d\n",
+ 		       regno, i,
+ 		       reg_dead_at_pred (offset, bit, i));
+ 	    }
+ 	  if ((basic_block_maybe_live_at_end[i][offset] & bit)
+ 	      && reg_dead_at_pred (offset, bit, i)
+ 	      && !(basic_block_live_at_start[i][offset] & bit)
+ 	      && IS_STACK_MODE (GET_MODE (regno_reg_rtx[regno])))
+ 	    {
+ 	      /* A stack register that is live at the exit of the
+                  block and not live on entry */
+ 	      if (stack_reg_dump_file)
+ 		{
+ 		  fprintf (stack_reg_dump_file,
+ 		  "\nstack reg%d in block %d live at end but not at start\n",
+ 			   regno, i);
+ 		}
+ 	      bzero (blocks_visited, n_basic_blocks * sizeof (char));
+ 	      bzero (death_blocks, n_basic_blocks * sizeof (rtx));
+ 	      num_visits = 0;
+ 	      successful_visit = visit_till_dies (regno, i);
+ 	      if (stack_reg_dump_file)
+ 		{
+ 		  fprintf (stack_reg_dump_file, " blocks visited : ");
+ 		  for (j = 0; j < n_basic_blocks; j++)
+ 		    {
+ 		      if (blocks_visited[j])
+ 			{
+ 			  fprintf (stack_reg_dump_file, "%d ", j);
+ 			}
+ 		    }
+ 		  fprintf (stack_reg_dump_file, "\n");
+ 		}
+ 	      successful_visit = 
+ 	        successful_visit && death_blocks_ok (regno);
+ 	      bzero (blocks_defined, n_basic_blocks * sizeof (char));
+ 	      blocks_defined[i] = 1;
+ 	      reg_defined_elsewhere = reg_def_in_unvisited (offset, bit, i);
+ 	      reg_set_or_stored 
+ 		= reg_only_set_or_stored (regno, i, &cmprd, &only_cmp);
+ 	      if (successful_visit
+ 		  && !reg_defined_elsewhere
+ 		  && reg_set_or_stored)
+ 		{  /* This reg was never used in any computation after
+                       this set until it's death - so don't keep
+                       it in stack reg after block i.  Allocate a temp slot
+                       for it and store it there at the end of block i.  
+                       In all visited blocks replace regno with this
+                       temp slot.  */
+ 		  if (stack_reg_dump_file)
+ 		    {
+ 		      fprintf (stack_reg_dump_file,
+ 			  " only loaded or stored in all visited blocks\n");
+ 		    }
+ 		  if (store_into_temp (regno, i))
+ 		    {
+ 		      if (stack_reg_dump_file)
+ 			{
+ 			  fprintf (stack_reg_dump_file,
+ 			  " replaced by temp slot in all blocks visited\n");
+ 			}
+ 		      replace_with_temp_slot (regno, i);
+ 		    }
+ 		}
+ 	      else if (successful_visit && cmprd)
+ 		{
+ 		  /* In each block where regno is defined by a computation
+                      store it and reload it to avoid precision problems
+                      in comparison */
+ 		  offload_reg (regno);
+ 		}
+ 	      if (stack_reg_dump_file)
+ 		{
+ 		  fprintf (stack_reg_dump_file,
+ 			   "  successful visit %d  cmprd %d\n", successful_visit, cmprd);
+ 		}
+ 	    }
+ 	}
+     }
+   obstack_free (&momentary_obstack, storage);
+ }
+ 
+ 
+ /*
+   The blocks where the stack reg dies on the visit have been
+   marked by death_blocks[block_num] being set to the NEXT_INSN
+   of the insn where it dies in the block.  
+   For each of these blocks either the register must not be redefined
+   in the block or none of the successors of the block have been
+   visited.  
+ */
+ 
+ static int
+ death_blocks_ok (regno)
+      int regno;
+ {
+   int i, successor_visited;
+ 
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       if (death_blocks[i])
+ 	{
+ 	  successor_visited = 0;
+ 	  if (fall_thru_block[i] != -1
+ 	      && blocks_visited[fall_thru_block[i]])
+ 	    {
+ 	      successor_visited = 1;
+ 	    }
+ 	  if (successor_visited == 0 && jump_target_block[i] != -1
+ 	      && blocks_visited[jump_target_block[i]])
+ 	    {
+ 	      successor_visited = 1;
+ 	    }
+ 	  if (successor_visited == 0)
+ 	    {
+ 	      continue;
+ 	    }
+ 	  else if (reg_set_between_p (regno_reg_rtx[regno],
+ 				      PREV_INSN (death_blocks[i]),
+ 				      NEXT_INSN (basic_block_end[i])))
+ 	    {
+ 	      return (0);
+ 	    }
+ 	}
+     }
+   return (1);
+ }
+ 
+ 
+ /*
+   Like offload_if_necessary but for stack registers used in equality
+   comparisons in one basic block and computed in another.  The offload
+   and reload are done at the place of computation.  
+ */
+ static void
+ offload_reg (regno)
+      int regno;
+ {
+   int block, reg_loaded;
+   rtx last_set_insn, new_insn;
+ 
+   if (stack_reg_dump_file)
+     {
+       fprintf (stack_reg_dump_file,
+ 	       "offload compared reg %d\n", regno);
+     }
+   for (block = 0; block < n_basic_blocks; block++)
+     {
+       if (blocks_defined[block])
+ 	{
+ 	  if (stack_reg_dump_file)
+ 	    {
+ 	      fprintf (stack_reg_dump_file,
+ 		       " defined in block %d\n", block);
+ 	    }
+ 	  last_set_insn = NULL;
+ 	  reg_loaded 
+ 	    = reg_last_loaded (block, basic_block_end[block], regno, &last_set_insn);
+ 	  if (stack_reg_dump_file)
+ 	    {
+ 	      fprintf (stack_reg_dump_file,
+ 		       "  reg loaded %d ", reg_loaded);
+ 	      if (last_set_insn)
+ 		fprintf (stack_reg_dump_file,
+ 			 " last_set_insn %d", INSN_UID (last_set_insn));
+ 	      fprintf (stack_reg_dump_file, "\n");
+ 	    }
+ 	  if (reg_loaded == 0 && last_set_insn)
+ 	    {
+ 	      if (stack_reg_dump_file)
+ 		{
+ 		  fprintf (stack_reg_dump_file,
+ 			   "   actually offloading\n");
+ 		}
+ 	      if (reg_temp_slot[regno] == NULL)
+ 		{
+ 		  reg_temp_slot[regno] 
+ 		    = assign_stack_local (GET_MODE (regno_reg_rtx[regno]),
+ 			    GET_MODE_SIZE (GET_MODE (regno_reg_rtx[regno])),
+ 					-1);
+ 		}
+ 	      MEM_VOLATILE_P (reg_temp_slot[regno]) = 1;
+ 	      new_insn 
+ 		= emit_insn_before (
+ 				   gen_rtx (SET, 0,
+ 				reg_temp_slot[regno], regno_reg_rtx[regno]),
+ 				   NEXT_INSN (last_set_insn));
+ 	      REG_NOTES (new_insn) 
+ 	        = gen_rtx (EXPR_LIST, REG_DEAD,
+ 			 regno_reg_rtx[regno],
+ 			 REG_NOTES (new_insn));
+ 	      reg_n_deaths[regno]++;
+ 	      new_insn 
+ 		= emit_insn_before (
+ 				   gen_rtx (SET, 0,
+ 				regno_reg_rtx[regno], reg_temp_slot[regno]),
+ 				   NEXT_INSN (new_insn));
+ 	      if (basic_block_end[block] == last_set_insn)
+ 		{
+ 		  basic_block_end[block] = new_insn;
+ 		}
+ 	    }
+ 	}
+     }
+ }
+ 
+ /*
+   If the reg given by offset an bit in the live vecotrs is not live
+   at the end of any blocks that are the predecessors of blocknum
+   (except blocknum itself)
+     return 1
+   else
+     return 0
+ */
+ static int
+ reg_dead_at_pred (offset, bit, blocknum)
+      int offset, bit, blocknum;
+ {
+   rtx head, jump;
+   int i;
+ 
+   head = basic_block_head[blocknum];
+ 
+   if (GET_CODE (head) == CODE_LABEL)
+     for (jump = LABEL_REFS (head);
+ 	 jump != head;
+ 	 jump = LABEL_NEXTREF (jump))
+       {
+ 	for (i = 0; i < n_basic_blocks; i++)
+ 	  {
+ 	    if (basic_block_end[i] == CONTAINING_INSN (jump))
+ 	      break;
+ 	  }
+ 	if (i == n_basic_blocks)
+ 	  {
+ 	    return (0);
+ 	  }
+ 	if (i != blocknum)
+ 	  {
+ 	    if (basic_block_maybe_live_at_end[i][offset] & bit)
+ 	      {
+ 		return (0);
+ 	      }
+ 	  }
+       }
+ 
+   if ((blocknum - 1) == -1 ||
+       simplejump_p (basic_block_end[blocknum - 1]) ||
+       !(basic_block_maybe_live_at_end[blocknum - 1][offset] & bit))
+     {
+       return (1);
+     }
+   return (0);
+ 
+ }
+ 
+ /*
+   If the definition of the register in some visited block is
+   done by a block that has not been visited then return 1
+ */
+ static int
+ reg_def_in_unvisited (offset, bit, blocknum)
+      int offset, bit, blocknum;
+ {
+   int i, j, ret_val;
+   rtx head, jump;
+ 
+   ret_val = 0;
+ 
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       if (i != blocknum && blocks_visited[i])
+ 	{
+ 	  head = basic_block_head[i];
+ 
+ 	  if (GET_CODE (head) == CODE_LABEL)
+ 	    for (jump = LABEL_REFS (head);
+ 		 jump != head;
+ 		 jump = LABEL_NEXTREF (jump))
+ 	      {
+ 		for (j = 0; j < n_basic_blocks; j++)
+ 		  {
+ 		    if (basic_block_end[j] == CONTAINING_INSN (jump))
+ 		      break;
+ 		  }
+ 		if (j == n_basic_blocks)
+ 		  {
+ 		    ret_val = 1;
+ 		  }
+ 		if (blocks_visited[j] == 0 && j != i)
+ 		  {
+ 		    if (basic_block_maybe_live_at_end[j][offset] & bit)
+ 		      {
+ 			blocks_defined[j] = 1;
+ 			ret_val = 1;
+ 		      }
+ 		  }
+ 	      }
+ 
+ 	  if ((i - 1) != -1
+ 	      && !simplejump_p (basic_block_end[i - 1])
+ 	      && blocks_visited[i - 1] == 0
+ 	      && basic_block_maybe_live_at_end[i - 1][offset] & bit)
+ 	    {
+ 	      blocks_defined[i - 1] = 1;
+ 	      ret_val = 1;
+ 	    }
+ 	}
+     }
+   return (ret_val);
+ }
+ 
+ 
+ /* regno is never used in any computation from it's set in
+    source_blocknum until it's death - so don't keep
+    it in stack reg after source_blocknum.  Allocate a temp slot
+    for it and store it there at the end of block source_blocknum.
+    In all visited blocks replace regno with this temp slot. 
+    In blocks where regno dies the replacement is done
+    up until the insn in which regno dies.  
+ */
+ static void
+ replace_with_temp_slot (regno, source_blocknum)
+ {
+   int i, had_call, num_insns;
+   rtx insn, note;
+   register int offset = regno / REGSET_ELT_BITS;
+   register int bit = 1 << (regno % REGSET_ELT_BITS);
+   register int compl_bit;
+ 
+   compl_bit = ~bit;
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       if (blocks_visited[i] && i != source_blocknum)
+ 	{
+ 	  basic_block_live_at_start[i][offset] &= compl_bit;
+ 	  if (!death_blocks[i])
+ 	    {
+ 	      basic_block_maybe_live_at_end[i][offset] &= compl_bit;
+ 	    }
+ 	  had_call = 0;
+ 	  num_insns = 0;
+ 	  for (insn = basic_block_head[i];
+ 	       insn && insn != death_blocks[i]
+ 	       && insn != NEXT_INSN (basic_block_end[i]);
+ 	       insn = NEXT_INSN (insn))
+ 	    {
+ 	      num_insns++;
+ 	      if (GET_CODE (insn) == CALL_INSN)
+ 	        had_call = 1;
+ 	      if (GET_CODE (insn) == INSN)
+ 		{
+ 		  init_undo_buf ();
+ 		  subst_in_insn (insn, PATTERN (insn), regno_reg_rtx[regno],
+ 				 reg_temp_slot[regno], 0, 0);
+ 		  if (GET_CODE (reg_temp_slot[regno]) == REG
+ 		      && GET_CODE (PATTERN (insn)) == SET)
+ 		    {
+ 	              register int n_offset = 
+ 	                REGNO (reg_temp_slot[regno]) / REGSET_ELT_BITS;
+ 	              register REGSET_ELT_TYPE n_bit
+ 	                = (REGSET_ELT_TYPE) 1 
+ 	                  << (REGNO (reg_temp_slot[regno]) % REGSET_ELT_BITS);
+ 	              basic_block_live_at_start[i][n_offset] |= n_bit;
+ 	              reg_basic_block[REGNO (reg_temp_slot[regno])] = REG_BLOCK_GLOBAL;
+ 		      if (rtx_equal_p (reg_temp_slot[regno], 
+ 		                       SET_DEST (PATTERN (insn))))
+ 		        {
+ 		          reg_n_sets[REGNO (reg_temp_slot[regno])]++;
+ 		          reg_n_refs[REGNO (reg_temp_slot[regno])]++;
+                           if (GET_CODE (SET_SRC (PATTERN (insn)))
+                               == CONST_DOUBLE)
+                             {
+                               union
+                                 {
+                                   int i[2];
+                                   double d;
+                                 }
+                               u1;
+                               union
+                                 {
+                                   int i;
+                                   float f;
+                                 }
+                               u2;
+                               u1.i[0] = 
+                                 CONST_DOUBLE_LOW (SET_SRC (PATTERN (insn)));
+                               u1.i[1] = 
+                                 CONST_DOUBLE_HIGH (SET_SRC (PATTERN (insn)));
+                               u2.f = u1.d;
+                               SET_SRC (PATTERN (insn)) = 
+                                 gen_rtx (CONST_INT, 0, u2.i);
+                             }
+                           else
+                             {
+ 		              PUT_MODE (SET_SRC (PATTERN (insn)), 
+ 		                    GET_MODE (reg_temp_slot[regno]));
+ 
+ 		            }
+ 		        }
+ 		      if (rtx_equal_p (reg_temp_slot[regno], 
+ 		                       SET_SRC (PATTERN (insn))))
+ 		        {
+ 		          PUT_MODE (SET_DEST (PATTERN (insn)), 
+ 		                    GET_MODE (reg_temp_slot[regno]));
+ 		          reg_live_length[REGNO (reg_temp_slot[regno])] 
+ 		            += num_insns;
+ 		          reg_n_refs[REGNO (reg_temp_slot[regno])]++;
+ 		          if (had_call)
+ 		            {
+ 		              reg_n_calls_crossed[REGNO (reg_temp_slot[regno])]++;
+ 		            }
+ 		        }
+ 		    }
+ 		  INSN_CODE (insn) = recog (PATTERN (insn), insn, 0);
+ 		  if ((note = find_regno_note (insn, REG_DEAD, regno)) != NULL)
+ 		    {
+ 		      if (GET_CODE (reg_temp_slot[regno]) == REG)
+ 		        {
+ 		          XEXP (note, 0) = reg_temp_slot[regno];
+ 		          reg_n_deaths[REGNO (reg_temp_slot[regno])]++;
+ 		        }
+ 		      else
+ 		        remove_note (insn, note);
+ 		    }
+ 		}
+ 	    }
+ 	}
+     }
+ }
+ 
+ 
+ 
+ /*
+   If in each block_visited (except source_blocknum) regno is only
+   set, or used as a source in a store then
+     return 1
+   else
+     return 0
+   *used_in_cmp is set to 1 if regno is used in a comparison
+   in a block and it was not last set by a load before that
+   comparison
+   *only_cmp is set to 1 if the only other use of regno besides
+   as a dest or source of a store is in comparison, otherwise it
+   is set to 0
+ */
+ static int
+ reg_only_set_or_stored (regno, source_blocknum, used_in_cmp, only_cmp)
+      int regno, source_blocknum, *used_in_cmp, *only_cmp;
+ {
+   int i, ret_val;
+   rtx insn, cmp_part, last_set_insn;
+ 
+   ret_val = 1;
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       if (blocks_visited[i] && i != source_blocknum)
+ 	{
+ 	  for (insn = basic_block_head[i];
+ 	       insn && insn != death_blocks[i]
+ 	       && insn != NEXT_INSN (basic_block_end[i]);
+ 	       insn = NEXT_INSN (insn))
+ 	    {
+ 	      if (GET_CODE (insn) == INSN)
+ 		{
+ 		  if (reg_used_in_body (regno, PATTERN (insn)))
+ 		    {
+ 		      ret_val = 0;
+ 		      if (stack_reg_dump_file)
+ 			{
+ 			  fprintf (stack_reg_dump_file,
+ 				   "  reg used in body of insn %d\n", INSN_UID (insn));
+ 			}
+ 		      if (GET_CODE (PATTERN (insn)) == PARALLEL
+ 			&& GET_CODE (XVECEXP (PATTERN (insn), 0, 0)) == SET)
+ 			{
+ 			  cmp_part = XVECEXP (PATTERN (insn), 0, 0);
+ 			  last_set_insn = NULL;
+ 			  if (SET_DEST (cmp_part) == cc0_rtx
+ 			      && GET_CODE (SET_SRC (cmp_part)) == COMPARE
+ 			      && (GET_MODE (SET_SRC (cmp_part)) == CCmode
+ 			          || GET_MODE (SET_SRC (cmp_part)) == CCFPEQmode
+ 			          || GET_MODE (SET_SRC (cmp_part)) == VOIDmode)
+ 			      && GET_CODE (XEXP (SET_SRC (cmp_part), 0)) == REG
+ 			      && REGNO (XEXP (SET_SRC (cmp_part), 0)) == regno
+ 			      && (GET_CODE (XEXP (SET_SRC (cmp_part), 1)) != REG
+ 			          || GET_MODE (SET_SRC (cmp_part)) == CCFPEQmode)
+ 			      && !reg_last_loaded (i, PREV_INSN (insn),
+ 				       REGNO (XEXP (SET_SRC (cmp_part), 0)),
+ 						   &last_set_insn)
+ 			      && !last_set_insn
+ 			      && tests_equality (NEXT_INSN (insn)))
+ 			    {
+ 			      *used_in_cmp = 1;
+ 			    }
+ 			  else
+ 			    {
+ 			      *only_cmp = 0;
+ 			    }
+ 			}
+ 		      else
+ 			{
+ 			  *only_cmp = 0;
+ 			}
+ 		    }
+ 		}
+ 	    }
+ 	}
+     }
+   return (ret_val);
+ }
+ 
+ /*
+   If regno is used in insn is anyway except as a dest or source of a set
+     return 1
+   else
+     return 0
+ */
+ static int
+ reg_used_in_body (regno, body)
+      int regno;
+      rtx body;
+ {
+   int i, ret_val = 0;
+ 
+   if (GET_CODE (body) == SET)
+     {
+       if (GET_CODE (SET_DEST (body)) != REG)
+ 	{
+ 	  if (reg_overlap_mentioned_p (regno_reg_rtx[regno],
+ 				       SET_DEST (body)))
+ 	    {
+ 	      return (1);
+ 	    }
+ 	}
+       else if (REGNO (SET_DEST (body)) == regno)
+ 	{
+ 	  if (GET_CODE (SET_SRC (body)) != MEM
+ 	      && GET_CODE (SET_SRC (body)) != REG
+ 	      && GET_CODE (SET_SRC (body)) != CONST_DOUBLE)
+ 	    {
+ 	      return (1);
+ 	    }
+ 	}
+ 
+       if (GET_CODE (SET_SRC (body)) != REG)
+ 	{
+ 	  if (reg_overlap_mentioned_p (regno_reg_rtx[regno],
+ 				       SET_SRC (body)))
+ 	    {
+ 	      return (1);
+ 	    }
+ 	}
+       else if (REGNO (SET_SRC (body)) == regno)
+ 	{
+ 	  if (/*GET_CODE (SET_DEST (body)) != REG
+ 	      && */ GET_CODE (SET_DEST (body)) != MEM)
+ 	    {
+ 	      return (1);
+ 	    }
+ 	}
+       return (0);
+     }
+   else if (GET_CODE (body) == CLOBBER)
+     {
+       if (GET_CODE (SET_DEST (body)) == REG && REGNO (SET_DEST (body)) == regno)
+ 	{
+ 	  return (1);
+ 	}
+       return (0);
+     }
+   else if (GET_CODE (body) == PARALLEL)
+     {
+       for (i = 0; i < XVECLEN (body, 0); i++)
+ 	{
+ 	  ret_val |= reg_used_in_body (regno, XVECEXP (body, 0, i));
+ 	  if (ret_val)
+ 	    {
+ 	      return (1);
+ 	    }
+ 	}
+       return (ret_val);
+     }
+   else
+     {
+       return (1);
+     }
+ }
+ 
+ /*
+    If the stack reg regno has not already been allocated a temp slot then
+      allocate one for it. 
+    Store the last value of regno in block# source_blocknum into it's
+    temp_slot.  
+    Mark the last use of regno in the block as REG_DEAD
+ */
+ static int
+ store_into_temp (regno, source_blocknum)
+      int regno, source_blocknum;
+ {
+   rtx last_set, last_use, stack_slot, store_rtx, store_insn, note;
+   int found, insn_code_num, i;
+   register int offset;
+   register int bit;
+   register int compl_bit;
+ 
+ 
+   /* Find where regno is last set in source_blocknum */
+   last_set = basic_block_end[source_blocknum];
+   found = 0;
+   while (!found && last_set != PREV_INSN (basic_block_head[source_blocknum]))
+     {
+       if (GET_CODE (last_set) == INSN)
+ 	{
+ 	  if (GET_CODE (PATTERN (last_set)) == PARALLEL)
+ 	    {
+ 	      for (i = 0; i < XVECLEN (PATTERN (last_set), 0); i++)
+ 		{
+ 		  if (GET_CODE (XVECEXP (PATTERN (last_set), 0, i)) == SET)
+ 		    {
+ 		      if (GET_CODE (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == REG &&
+ 			  REGNO (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == regno)
+ 			{
+ 			  return (0);
+ 			}
+ 		    }
+ 		  else if (GET_CODE (XVECEXP (PATTERN (last_set), 0, i)) == CLOBBER)
+ 		    {
+ 		      if (GET_CODE (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == REG &&
+ 			  REGNO (SET_DEST (XVECEXP (PATTERN (last_set), 0, i))) == regno)
+ 			{
+ 			  return (0);
+ 			}
+ 		    }
+ 		  else
+ 		    {
+ 		      return (0);
+ 		    }
+ 		}
+ 	    }
+ 	  if ((GET_CODE (PATTERN (last_set)) == SET ||
+ 	       GET_CODE (PATTERN (last_set)) == CLOBBER) &&
+ 	      GET_CODE (SET_DEST (PATTERN (last_set))) == REG &&
+ 	      REGNO (SET_DEST (PATTERN (last_set))) == regno)
+ 	    {
+ 	      if (GET_CODE (PATTERN (last_set)) == CLOBBER)
+ 		return (0);
+ 	      if (GET_CODE (SET_SRC (PATTERN (last_set))) != MEM)
+ 		return (0);
+ 	      found = 1;
+ 	    }
+ 	}
+       if (!found)
+ 	{
+ 	  last_set = PREV_INSN (last_set);
+ 	}
+     }
+   if (!found)
+     {
+       return (0);
+     }
+ 
+ 
+   /* Allocate a temp slot and store the value that is loaded into
+      regno at last_set into that temp slot and place the insn to
+      do this right after the load to regno */
+   if (reg_temp_slot[regno] == NULL)
+     {
+ #ifdef SPARE_REGS
+       if (max_reg_num () < max_regno)
+         {
+           if (GET_MODE (SET_DEST (PATTERN (last_set))) == SFmode)
+             {
+               reg_temp_slot[regno] = gen_reg_rtx (SImode);
+             }
+           else
+             reg_temp_slot[regno] 
+ 	      = assign_stack_local (GET_MODE (SET_DEST (PATTERN (last_set))),
+ 		   GET_MODE_SIZE (GET_MODE (SET_DEST (PATTERN (last_set)))),
+ 			    -1);
+         }
+       else
+ #endif
+         reg_temp_slot[regno] 
+ 	  = assign_stack_local (GET_MODE (SET_DEST (PATTERN (last_set))),
+ 		   GET_MODE_SIZE (GET_MODE (SET_DEST (PATTERN (last_set)))),
+ 			    -1);
+     }
+   store_rtx = gen_rtx (SET, 0, reg_temp_slot[regno],
+ 		       copy_rtx (SET_SRC (PATTERN (last_set))));
+   if (GET_CODE (reg_temp_slot[regno]) == REG )
+     {
+       if (GET_CODE (SET_SRC (store_rtx)) == CONST_DOUBLE)
+         {
+           union
+             {
+               int i[2];
+               double d;
+             }
+           u1;
+           union
+             {
+               int i;
+               float f;
+             }
+           u2;
+           u1.i[0] = CONST_DOUBLE_LOW (SET_SRC (store_rtx));
+           u1.i[1] = CONST_DOUBLE_HIGH (SET_SRC (store_rtx));
+           u2.f = u1.d;
+           SET_SRC (store_rtx) = 
+             gen_rtx (CONST_INT, 0, u2.i);
+         }
+       else
+         {
+           PUT_MODE (SET_SRC (store_rtx), GET_MODE (reg_temp_slot[regno]));
+         }
+       reg_n_sets[REGNO (reg_temp_slot[regno])]++;
+       reg_n_refs[REGNO (reg_temp_slot[regno])]++;
+       reg_live_length[REGNO (reg_temp_slot[regno])] = 2;
+     }
+   insn_code_num = recog (store_rtx, last_set);
+   if (insn_code_num < 0)
+     {
+       return (0);
+     }
+   store_insn = emit_insn_after (store_rtx, PREV_INSN (last_set));
+   INSN_CODE (store_insn) = insn_code_num;
+ 
+   /* Find where regno is last use in source_blocknum */
+   last_use = basic_block_end[source_blocknum];
+   found = 0;
+   while (!found && last_use != PREV_INSN (basic_block_head[source_blocknum]))
+     {
+       if (GET_CODE (last_use) == INSN)
+ 	{
+ 	  if (reg_overlap_mentioned_p (regno_reg_rtx[regno], PATTERN (last_use)))
+ 	    {
+ 	      found = 1;
+ 	    }
+ 	}
+       if (!found)
+ 	{
+ 	  last_use = PREV_INSN (last_use);
+ 	}
+     }
+   offset = regno / REGSET_ELT_BITS;
+   bit = 1 << (regno % REGSET_ELT_BITS);
+   compl_bit = ~bit;
+   if (!found)
+     { /* regno was only loaded and never used - the load can be deleted */
+       delete_insn_for_stacker (last_set);
+       basic_block_maybe_live_at_end[source_blocknum][offset] &= compl_bit;
+       return (1);
+     }
+   /* Mark regno as dead at last_use */
+   note = gen_rtx (EXPR_LIST, REG_DEAD, regno_reg_rtx[regno],
+ 		  REG_NOTES (last_use));
+   XEXP (note, 1) = REG_NOTES (last_use);
+   REG_NOTES (last_use) = note;
+   basic_block_maybe_live_at_end[source_blocknum][offset] &= compl_bit;
+   return (1);
+ }
+ 
+ 
+ /*
+   Starting at block# block_num visit all successor blocks recursively
+   stopping at a block where regno is not live at exit or regno
+   is set in block
+ */
+ static int
+ visit_till_dies (regno, block_num)
+      int regno, block_num;
+ {
+   register int offset = regno / REGSET_ELT_BITS;
+   register int bit = 1 << (regno % REGSET_ELT_BITS);
+   int ret_val = 1;
+   int already_visited;
+   rtx reg_death = NULL;
+ 
+   already_visited = blocks_visited[block_num];
+   blocks_visited[block_num] = 1;
+   if (num_visits > n_basic_blocks * 2)
+     { /* Failed to find where regno dies */
+       return (0);
+     }
+   if (already_visited)
+     {
+       num_visits++;
+       return (1);
+     }
+   num_visits++;
+   if ((basic_block_maybe_live_at_end[block_num][offset] & bit)
+       && !(reg_death = reg_dies_in_block (regno, block_num)))
+     {
+       if (jump_target_block[block_num] != -1)
+ 	{
+ 	  ret_val = visit_till_dies (regno, jump_target_block[block_num]);
+ 	}
+       if (ret_val && fall_thru_block[block_num] != -1)
+ 	{
+ 	  ret_val = visit_till_dies (regno, fall_thru_block[block_num]);
+ 	}
+       return (ret_val);
+     }
+   else
+     {
+       if (reg_death)
+ 	{
+ 	  death_blocks[block_num] = NEXT_INSN (reg_death);
+ 	}
+       return (1);
+     }
+ }
+ 
+ 
+ /* Return the insn where regno dies in the block if it does,
+    otherwise return NULL
+ */
+ static rtx
+ reg_dies_in_block (regno, block_num)
+      int regno, block_num;
+ {
+   rtx insn;
+ 
+   for (insn = basic_block_head[block_num];
+        insn && insn != NEXT_INSN (basic_block_end[block_num]);
+        insn = NEXT_INSN (insn))
+     {
+       if (GET_CODE (insn) == INSN && find_regno_note (insn, REG_DEAD, regno))
+ 	{
+ 	  return (insn);
+ 	}
+     }
+   return (NULL);
+ }
+ 
+ my_dump_block_info ()
+ {
+   int i;
+   int max_regno = max_reg_num();
+   for (i = 0; i < n_basic_blocks; i++)
+     {
+       register rtx head, jump;
+       register int regno;
+       fprintf (stack_reg_dump_file, "\nBasic block %d: first insn %d, last %d.\n",
+ 	       i,
+ 	       INSN_UID (basic_block_head[i]),
+ 	       INSN_UID (basic_block_end[i]));
+       /* The control flow graph's storage is freed
+ 	 now when flow_analysis returns.
+ 	 Don't try to print it if it is gone.  */
+       fprintf (stack_reg_dump_file, "Succesor blocks: %d %d\n",
+ 	       fall_thru_block[i], jump_target_block[i]);
+       fprintf (stack_reg_dump_file, "\nRegisters live at start:");
+       for (regno = 0; regno < max_regno; regno++)
+ 	{
+ 	  register int offset = regno / REGSET_ELT_BITS;
+ 	  register int bit = 1 << (regno % REGSET_ELT_BITS);
+ 	  if (basic_block_live_at_start[i][offset] & bit)
+ 	    {
+ 	      fprintf (stack_reg_dump_file, " %d", regno);
+ 	    }
+ 	}
+       fprintf (stack_reg_dump_file, "\n");
+       fprintf (stack_reg_dump_file, "Registers live at end:");
+       for (regno = 0; regno < max_regno; regno++)
+ 	{
+ 	  register int offset = regno / REGSET_ELT_BITS;
+ 	  register int bit = 1 << (regno % REGSET_ELT_BITS);
+ 	  if (basic_block_maybe_live_at_end[i][offset] & bit)
+ 	    {
+ 	      fprintf (stack_reg_dump_file, " %d", regno);
+ 	    }
+ 	}
+       fprintf (stack_reg_dump_file, "\n");
+     }
+   fprintf (stack_reg_dump_file, "\n");
+ }
+ 
+ #define   MINUS0  0x80000000
+ 
+ /*
+   change floating point compares to integer compares
+ */
+ 
+ void
+ float_to_int_cmp (f, allow_new_jumps)
+      rtx f;
+ {
+   union
+     {
+       int i[2];
+       double d;
+     }
+   u1;
+   union
+     {
+       int i;
+       float f;
+     }
+   u2;
+   int block, found, next_is_ok, rev_new_targets, const_is_zero, no_new_jump,
+       change_org_jump, new_org_cond, rev_org_targets, new_jump_cond,
+       make_new_lab, new_lab_true;
+   rtx insn, sf_reg, sf_dead_note, last_set, mem_loaded, int_cmp, cmp_part,
+       op1, next, org_jump_insn, double_const, tmp, new_jump,  new_jump_insn, 
+       new_label, new_label_insn, gen_cmpsi_1 ();
+ 
+   if (HOST_FLOAT_FORMAT != TARGET_FLOAT_FORMAT
+       || HOST_FLOAT_FORMAT != IEEE_FLOAT_FORMAT)
+     {
+       return;
+     }
+   if (TARGET_IEEE_FP)
+     {
+       return;
+     }
+   insn = f;
+   for (insn; insn != NULL; insn = NEXT_INSN (insn))
+     {
+       if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == PARALLEL)
+ 	{
+ 	  if (GET_CODE (XVECEXP (PATTERN (insn), 0, 0)) == SET)
+ 	    {
+ 	      cmp_part = XVECEXP (PATTERN (insn), 0, 0);
+ 	      if (SET_DEST (cmp_part) == cc0_rtx
+ 		  && GET_CODE (SET_SRC (cmp_part)) == COMPARE
+ 		  && (GET_MODE (SET_SRC (cmp_part)) == CCmode
+ 		      || GET_MODE (SET_SRC (cmp_part)) == VOIDmode)
+ 		  && ( 
+ 		      (GET_CODE (XEXP (SET_SRC (cmp_part), 0)) == FLOAT_EXTEND
+ 		       && GET_CODE (XEXP (XEXP (SET_SRC (cmp_part), 0), 0)) == REG
+ 		       && REGNO (XEXP (XEXP (SET_SRC (cmp_part), 0), 0)) == FIRST_FLOAT_REG
+ 	               && GET_MODE (XEXP (XEXP (SET_SRC (cmp_part), 0), 0)) == SFmode)
+ 	              || /* Will have to make sure later it was loaded 
+ 	                    from SFmode */
+ 		      (GET_CODE (XEXP (SET_SRC (cmp_part), 0)) == REG
+ 		       && REGNO (XEXP (SET_SRC (cmp_part), 0)) == FIRST_FLOAT_REG
+ 	               && GET_MODE (XEXP (SET_SRC (cmp_part), 0)) == DFmode)
+ 	             )
+ 		  && GET_CODE (XEXP (SET_SRC (cmp_part), 1)) == MEM)
+ 		{
+ 		  if (CONSTANT_POOL_ADDRESS_P (XEXP (XEXP (SET_SRC (cmp_part), 1), 0)))
+ 		    {
+ 		      double_const
+ 			= get_pool_constant (XEXP (XEXP (SET_SRC (cmp_part), 1), 0));
+ 		      if (GET_CODE (double_const) == CONST_DOUBLE)
+ 			{
+ 			  u1.i[0] = CONST_DOUBLE_LOW (double_const);
+ 			  u1.i[1] = CONST_DOUBLE_HIGH (double_const);
+ 			  u2.f = u1.d;
+ 			  if (GET_CODE (XEXP (SET_SRC (cmp_part), 0)) == FLOAT_EXTEND)
+ 			    sf_reg = XEXP (XEXP (SET_SRC (cmp_part), 0), 0);
+ 			  else
+ 			    sf_reg = XEXP (SET_SRC (cmp_part), 0);
+ 			  sf_dead_note
+ 			    = find_regno_note (insn, REG_DEAD, REGNO (sf_reg));
+ 			}
+ 		      else
+ 			{
+ 			  double_const = NULL;
+ 			  sf_dead_note = NULL;
+ 			}
+ 		    }
+ 		  else
+ 		    {
+ 		      double_const = NULL;
+ 		      sf_dead_note = NULL;
+ 		    }
+ 
+ 		  next_is_ok = 1;
+ 		  no_new_jump = 0;
+ 		  const_is_zero = 0;
+ 		  if (u1.d == 0.0)
+ 		    {  /* 0.0 needs special handling because -0.0 has
+ 		          a different representation */
+ 		      const_is_zero = 1;
+ 		      next_is_ok = 0;
+ 		      rev_new_targets = 0;
+ 		      change_org_jump = 0;
+ 		      rev_org_targets = 0;
+ 		      new_jump_cond = EQ;
+ 		      make_new_lab = 0;
+ 		      new_lab_true = 0;
+ 		      next = NEXT_INSN (insn);
+ 		      if (allow_new_jumps
+ 		          && GET_CODE (next) == JUMP_INSN
+ 		          && GET_CODE (SET_SRC (PATTERN (next))) == IF_THEN_ELSE)
+ 			{
+ 			  org_jump_insn = next;
+ 			  if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == LT
+ 			      && XEXP (SET_SRC (PATTERN (next)), 1) == pc_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      rev_new_targets = 1;
+ 			    }			  
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == GT
+ 			      && XEXP (SET_SRC (PATTERN (next)), 1) == pc_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      rev_new_targets = 1;
+ 			      change_org_jump = 1;
+ 			      new_org_cond = LE;
+ 			      rev_org_targets = 1;
+ 			      no_new_jump = 1;
+ 			    } 
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == EQ
+ 			      && XEXP (SET_SRC (PATTERN (next)), 1) == pc_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      new_jump_cond = NE;
+ 			      rev_new_targets = 1;
+ 			      /* The original jump will jump to the new
+ 			         label, that will be placed immediately
+ 			         after the new jump.  */
+ 			      make_new_lab = 1;
+ 			      /* The new label is to be jumped to
+ 			         if the condition is true */
+ 			      new_lab_true = 1;
+ 			    } 
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == NE
+ 			      && XEXP (SET_SRC (PATTERN (next)), 1) != pc_rtx
+ 			      && XEXP (SET_SRC (PATTERN (next)), 2) == pc_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			      && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      change_org_jump = 1;
+ 			      new_org_cond = EQ;
+ 			      new_jump_cond = NE;
+ 			      /* The original jump will jump to the new
+ 			         label, that will be placed immediately
+ 			         after the new jump.  */
+ 			      make_new_lab = 1;
+ 			      /* The new label is to be jumped to
+ 			         if the condition is true */
+ 			      new_lab_true = 1;
+ 			    } 
+ 			  else if ((GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == GE
+ 			            && XEXP (SET_SRC (PATTERN (next)), 1) == pc_rtx
+ 			            && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			            && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			           ||
+ 			           (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == LT
+ 			            && XEXP (SET_SRC (PATTERN (next)), 1) != pc_rtx
+ 			            && XEXP (SET_SRC (PATTERN (next)), 2) == pc_rtx
+ 			            && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			            && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx))
+ 			    {
+ 			      next_is_ok = 1;
+ 			      change_org_jump = 1;
+ 			      new_org_cond = GE;
+ 			      new_jump_cond = NE;
+ 			      rev_new_targets = 1;
+ 			      /* The original jump will jump to the new
+ 			         label, that will be placed immediately
+ 			         after the new jump.  */
+ 			      make_new_lab = 1;
+ 			      /* The new label is to be jumped to
+ 			         if the condition is true */
+ 			      new_lab_true = 1;
+ 			    } 
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == GT
+ 			           && XEXP (SET_SRC (PATTERN (next)), 1) != pc_rtx
+ 			           && XEXP (SET_SRC (PATTERN (next)), 2) == pc_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      no_new_jump = 1;
+ 			    }
+ 			  else if ((GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == GE
+ 			            || GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == EQ)
+ 			           && XEXP (SET_SRC (PATTERN (next)), 1) != pc_rtx
+ 			           && XEXP (SET_SRC (PATTERN (next)), 2) == pc_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			    }
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == NE
+ 			           && XEXP (SET_SRC (PATTERN (next)), 1) == pc_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 0) == cc0_rtx
+ 			           && XEXP (XEXP (SET_SRC (PATTERN (next)), 0), 1) == const0_rtx)
+ 			    {
+ 			      next_is_ok = 1;
+ 			    }
+ 			  else if (GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0)) == LE)
+ 			    {
+ 			      next_is_ok = 1;
+ 			      no_new_jump = 1;
+ 			    }
+ 			}
+ 		    }
+ 		  if (sf_dead_note
+ 		      && next_is_ok
+ 		      && u1.d >= 0.0
+ 		      && ((double) u2.f == u1.d)
+ 		      && ((float) u1.d == u2.f))
+ 		    { /* Find where the sf_reg was loaded from.  */
+ 		      last_set = PREV_INSN (insn);
+ 		      found = 0;
+ 		      while (!found && last_set)
+ 			{
+ 			  if (GET_CODE (last_set) == INSN)
+ 			    {
+ 			      if (GET_CODE (PATTERN (last_set)) == SET
+ 				  && rtx_equal_p (sf_reg,
+ 					      SET_DEST (PATTERN (last_set)))
+ 			          &&
+ 			          (GET_CODE (SET_SRC (PATTERN (last_set))) 
+ 			              == MEM ||
+ 			           (GET_CODE (SET_SRC (PATTERN (last_set))) 
+ 			             == FLOAT_EXTEND 
+ 			            &&
+ 			            GET_CODE (XEXP (SET_SRC (PATTERN (last_set)),0))
+ 			                      == MEM)
+ 				  ))
+ 				{
+ 				  if (GET_CODE (SET_SRC (PATTERN (last_set))) 
+ 			               == FLOAT_EXTEND)
+ 			            {
+ 			              mem_loaded = 
+ 			                XEXP (SET_SRC (PATTERN (last_set)),0);
+ 				      found = 1;
+ 			            }
+ 			          else if (GET_CODE (XEXP (SET_SRC (cmp_part), 0)) 
+ 			                   == FLOAT_EXTEND)
+ 			            {
+ 			              mem_loaded = 
+ 			                SET_SRC (PATTERN (last_set));
+ 				      found = 1;
+ 			            }
+ 			          else
+ 			            {
+ 			              last_set = NULL;
+ 			            }
+ 				}
+ 		 	      else if (GET_CODE (PATTERN (last_set)) == SET
+ 		 	               && GET_CODE (SET_DEST (PATTERN (last_set)))
+ 		 	                   == REG
+ 		 	               && !IS_STACK_MODE (
+ 		 	                    GET_MODE (SET_DEST (PATTERN (last_set)))))
+ 		 	        {
+ 		 	          last_set = PREV_INSN (last_set);
+ 		 	        }
+ 			      else
+ 				last_set = NULL;
+ 			    }
+ 			  else if (GET_CODE (last_set) == NOTE)
+ 			    {
+ 			      last_set = PREV_INSN (last_set);
+ 			    }
+ 			  else
+ 			    last_set = NULL;
+ 			}
+ 		      if (last_set)
+ 			{
+ 			  op1 = gen_rtx (MEM, SImode, XEXP (mem_loaded,0));
+ 			  /* See if op1 is also in a register.  */
+ 			  if (next_nonnote_insn (last_set) == insn)
+ 			    {
+ 			      tmp = prev_nonnote_insn (last_set);
+ 			    }
+ 			  else
+ 			    {
+ 			      tmp = next_nonnote_insn (last_set);
+ 			      if (next_nonnote_insn (tmp) != insn)
+ 			        {
+ 			          tmp = NULL;
+ 			        }
+ 			    }
+ 			  if (tmp
+ 			      && GET_CODE (tmp) == INSN
+ 			      && GET_CODE (PATTERN (tmp)) == SET
+ 			      && GET_CODE (SET_DEST (PATTERN (tmp))) == REG
+ 			      && rtx_equal_p (op1, 
+ 			                      SET_SRC (PATTERN (tmp))))
+ 			    {
+ 			      op1 = SET_DEST (PATTERN (tmp));
+ 			    }
+ 			  int_cmp
+ 				= gen_cmpsi_1 (op1,
+ 					      gen_rtx (CONST_INT, 0, u2.i));
+ 			  PATTERN (insn) = int_cmp;
+ 			  INSN_CODE (insn) = recog (int_cmp, insn);
+ 			  remove_note (insn, sf_dead_note);
+ 			  reg_n_deaths[REGNO (sf_reg)]--;
+ 			  PUT_CODE (last_set, NOTE);
+ 			  NOTE_LINE_NUMBER (last_set) = NOTE_INSN_DELETED;
+ 			  NOTE_SOURCE_FILE (last_set) = 0;
+ 			  if (const_is_zero && change_org_jump)
+ 			    {
+ 			      PUT_CODE (XEXP (SET_SRC (PATTERN (org_jump_insn)), 0), 
+ 			                new_org_cond);  
+ 			      INSN_CODE (org_jump_insn)
+ 				= recog (PATTERN (org_jump_insn), org_jump_insn);
+ 			    }
+ 			  if (const_is_zero && rev_org_targets)
+ 			    {
+ 
+ 			      tmp = XEXP (SET_SRC (PATTERN (org_jump_insn)), 1);
+ 			      XEXP (SET_SRC (PATTERN (org_jump_insn)), 1)
+ 				    = XEXP (SET_SRC (PATTERN (org_jump_insn)), 2);
+ 			      XEXP (SET_SRC (PATTERN (org_jump_insn)), 2) = tmp;
+ 			      INSN_CODE (org_jump_insn)
+ 				= recog (PATTERN (org_jump_insn), org_jump_insn);
+ 			    }
+ 			  if (const_is_zero && !no_new_jump)
+ 			    {
+ 			      new_jump = copy_rtx (PATTERN (next));
+ 			      PUT_CODE (XEXP (SET_SRC (new_jump), 0), new_jump_cond);
+ 			      if (rev_new_targets)
+ 				{
+ 				  tmp = XEXP (SET_SRC (new_jump), 1);
+ 				  XEXP (SET_SRC (new_jump), 1)
+ 				    = XEXP (SET_SRC (new_jump), 2);
+ 				  XEXP (SET_SRC (new_jump), 2) = tmp;
+ 				}
+ 			      int_cmp
+ 				= gen_cmpsi_1 (op1,
+ 					    gen_rtx (CONST_INT, 0, MINUS0));
+ 			      int_cmp
+ 				= emit_insn_before (int_cmp, NEXT_INSN (next));
+ 			      INSN_CODE (int_cmp) = INSN_CODE (insn);
+ 			      new_jump_insn
+ 				= emit_jump_insn_after (new_jump, int_cmp);
+ 			      INSN_CODE (new_jump_insn)
+ 				= recog (new_jump, new_jump_insn);
+ 			    }
+ 			  if (const_is_zero && make_new_lab)
+ 			    {
+ 			      if (no_new_jump)
+ 			        abort ();
+                               new_label = gen_label_rtx ();
+                               new_label_insn 
+                                 = emit_label_after (new_label, new_jump_insn);
+                               ++LABEL_NUSES (new_label_insn);
+                               JUMP_LABEL (org_jump_insn) = new_label_insn;
+                               if (new_lab_true)
+                                 {
+ 			          XEXP (SET_SRC (PATTERN (org_jump_insn)), 1)
+ 			            = gen_rtx (LABEL_REF, VOIDmode, new_label);
+ 			          XEXP (SET_SRC (PATTERN (org_jump_insn)), 2)
+ 			            = pc_rtx;
+                                 }
+                               else
+                                 {
+ 			          XEXP (SET_SRC (PATTERN (org_jump_insn)), 1)
+ 			            = pc_rtx;
+ 			          XEXP (SET_SRC (PATTERN (org_jump_insn)), 2)
+ 			            = gen_rtx (LABEL_REF, VOIDmode, new_label);
+                                 }
+ 			      INSN_CODE (org_jump_insn)
+ 				 = recog (PATTERN (org_jump_insn), org_jump_insn);
+ 			    }
+ 			}
+ 		    }
+ 		}
+ 	    }
+ 	}
+     }
+ }
+ 
+ #endif
  #endif /* STACK_REGS */
